stages:
  - docker_images
  - build_unit_test
  - pre_deploy
  - deploy

.node_job: &node_job
  image: registry.gitlab.com/gitlab-org/gitter/webapp
  before_script:
    - node --version
    - npm --version
    - npm config set prefer-offline true
    - npm config set cache /npm_cache
    - mv /app/node_modules ./node_modules
    - npm install
  artifacts:
    expire_in: 31d
    when: always
    paths:
      - /npm_cache/
      - npm_cache/


validate:
  <<: *node_job
  stage: build_unit_test
  script:
    # TODO: Skip for now because we have new eslint failures
    - "echo 'TODO: Skip validation for now because we have new eslint failures'"
    #- make validate


test:
  <<: *node_job
  variables:
    BLUEBIRD_DEBUG: 1
    NEO4J_AUTH: none
  stage: build_unit_test
  services:
    - registry.gitlab.com/gitlab-org/gitter/webapp/mongo:latest
    - registry.gitlab.com/gitlab-org/gitter/webapp/elasticsearch:latest
    - redis:3.0
    - neo4j:2.3
  script:
    - make ci-test

package:
  <<: *node_job
  stage: build_unit_test
  script:
    # While testing the deploment, you can use cached artifacts instead of packaging every time which is slow
    #- (apt-get update && apt-get install unzip && curl -Ls https://gitlab.com/gitlab-org/gitter/webapp/-/jobs/60049410/artifacts/download -o previous-artifacts.zip && unzip previous-artifacts.zip) || (make package)
    - make package
  artifacts:
    paths:
      - output/app.tar.gz
      - output/assets.tar.gz
      - output/app/ASSET_TAG
      - output/app/GIT_COMMIT
      - output/app/VERSION
    expire_in: 1 week

.distribute_job: &distribute_job
  image: registry.gitlab.com/gitlab-org/gitter/webapp/deploy-build-image:latest
  stage: pre_deploy
  dependencies:
    - package
  script:
    - make upload-to-s3

distribute_beta:
  <<: *distribute_job
  only:
   - develop
  variables:
    DIST_S3_URL: s3://gitter-deployments/gitter-webapp/beta

distribute_beta_staging:
  <<: *distribute_job
  only:
    - /^feature\/.*$/
  variables:
    DIST_S3_URL: s3://gitter-deployments/gitter-webapp/beta-staging

distribute_staging:
  <<: *distribute_job
  only:
    - /^release\/.*$/
  variables:
    DIST_S3_URL: s3://gitter-deployments/gitter-webapp/staging

distribute_prod:
  <<: *distribute_job
  only:
    - tags
  variables:
    DIST_S3_URL: s3://gitter-deployments/gitter-webapp/prod

containerize:
  stage: deploy
  image: docker:latest
  dependencies:
    - package
  allow_failure: true
  variables:
    DOCKER_DRIVER: overlay
  services:
    - docker:dind
  script:
    - ls -la output
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
    - docker build -t registry.gitlab.com/gitlab-org/gitter/webapp/app:$CI_COMMIT_REF_SLUG -f Dockerfile-app-base .
    - docker push registry.gitlab.com/gitlab-org/gitter/webapp/app:$CI_COMMIT_REF_SLUG
  tags:
    - docker

deploy-build-image:
  stage: docker_images
  image: docker:latest
  services:
    - docker:dind
  only:
    - schedules
  variables:
    DOCKER_DRIVER: overlay
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
    - docker build -t registry.gitlab.com/gitlab-org/gitter/webapp/deploy-build-image:latest scripts/docker/deploy-build-image/
    - docker push registry.gitlab.com/gitlab-org/gitter/webapp/deploy-build-image:latest
  tags:
    - docker

.deploy_job: &deploy_job
  stage: deploy
  image: registry.gitlab.com/gitlab-org/gitter/webapp/deploy-build-image:latest
  variables:
    GIT_STRATEGY: none
  before_script:
    # run ssh-agent
    - eval $(ssh-agent -s)
    # add ssh key stored in SSH_PRIVATE_KEY variable to the agent store
    - ssh-add <(echo "$DEPLOY_KEY_ANSIBLE_REPO")
    - ssh-add <(echo "$INTERNAL_GITTER_NETWORK_SSH_KEY")
    - mkdir -p ~/.ssh
    - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
    # Make the infra tools available (like Ansible)
    - git clone git@gitlab.com:gl-infra/gitter-infrastructure.git
    - ANSIBLE_DIR=$(cd gitter-infrastructure/ansible && pwd) && echo $ANSIBLE_DIR
    - mkdir -p /root && echo "$ANSIBLE_VAULT_PASS" > /root/.vault_pass
  tags:
    - internal # This has to be within the Gitter network


deploy_beta: &deploy_beta
  <<: *deploy_job
  dependencies:
    - distribute_beta
  only:
   - develop
  script:
    - cd $ANSIBLE_DIR && ansible-playbook -i beta --vault-password-file "/root/.vault_pass" playbooks/gitter/webapp-deploy.yml
  environment:
    name: beta
    url: https://beta.gitter.im

deploy_beta_manual:
  <<: *deploy_beta
  when: manual

deploy_beta_staging: &deploy_beta_staging
  <<: *deploy_job
  dependencies:
    - distribute_beta_staging
  only:
    - /^feature\/.*$/
  script:
    - cd $ANSIBLE_DIR && ansible-playbook -i beta --vault-password-file "/root/.vault_pass" playbooks/gitter/webapp-staging-deploy.yml
  environment:
    name: beta_staging
    url: https://beta.gitter.im?gitter_next=true

deploy_beta_staging_manual:
  <<: *deploy_beta_staging
  when: manual

deploy_staging: &deploy_staging
  <<: *deploy_job
  dependencies:
    - distribute_staging
  only:
    - /^release\/.*$/
  script:
    - cd $ANSIBLE_DIR && ansible-playbook -i prod --vault-password-file "/root/.vault_pass" playbooks/gitter/webapp-staging-deploy.yml
  environment:
    name: staging
    url: https://gitter.im?gitter_next=true

deploy_staging_manual:
  <<: *deploy_staging
  when: manual

deploy_prod_manual: &deploy_prod
  <<: *deploy_job
  dependencies:
    - distribute_prod
  only:
    - tags
  # Production is only manual
  when: manual
  script:
    - cd $ANSIBLE_DIR && ansible-playbook -i prod --vault-password-file "/root/.vault_pass" playbooks/gitter/webapp-deploy.yml
  environment:
    name: prod
    url: https://gitter.im


docker-base:
  image: docker:latest
  stage: docker_images
  only:
    - schedules
  variables:
    DOCKER_DRIVER: overlay
  services:
    - docker:dind
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
    - docker build -t registry.gitlab.com/gitlab-org/gitter/webapp:latest .
    - docker push registry.gitlab.com/gitlab-org/gitter/webapp:latest
  tags:
    - docker

mongo-base:
  stage: docker_images
  image: docker:latest
  only:
    - schedules
  variables:
    DOCKER_DRIVER: overlay
  services:
    - docker:dind
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
    - docker build -t registry.gitlab.com/gitlab-org/gitter/webapp/mongo:latest scripts/docker/mongo-image/
    - docker push registry.gitlab.com/gitlab-org/gitter/webapp/mongo:latest
  tags:
    - docker

elasticsearch-base:
  stage: docker_images
  image: docker:latest
  only:
    - schedules
  variables:
    DOCKER_DRIVER: overlay
  services:
    - docker:dind
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
    - docker build -t registry.gitlab.com/gitlab-org/gitter/webapp/elasticsearch:latest scripts/docker/elasticsearch-image/
    - docker push registry.gitlab.com/gitlab-org/gitter/webapp/elasticsearch:latest
  tags:
    - docker
